# test hitidentification methods, CSV outputs, XLS outputs, heatmap images

import os
import filecmp
from XLS2CSV import xls2csv
from compareImages import compare

#execute the KNIME workflow "hitidentification" in batch mode
pwd = os.getcwd()
os.system('knime -nosplash -application org.knime.product.KNIME_BATCH_APPLICATION -nosave -reset -workflowDir="../" -option=32,DataURL,"file:%s/plate16x24/bscore.csv",String -option=47,XLS_LOCATION,"%s/plate16x24/bscore.xls",String -option=33,filename,"%s/test_data/bscore_meanSD.csv",String -option=35,filename,"%s/test_data/bscore_medianMAD.csv",String -option=44,filename,"%s/test_data/bscore_report_medianMAD.csv",String -option=45,filename,"%s/test_data/bscore_report_meanSD.csv",String -option=49,filename,"%s/test_data/bscore_medianMAD.xls",String -option=50,filename,"%s/test_data/bscore_meanSD.xls",String -option=51,filename,"%s/test_data/bscore_report_medianMAD.xls",String -option=52,filename,"%s/test_data/bscore_report_meanSD.xls",String -option=48,pathToSave,"%s/test_data/",String -option=37,expression,"Double k;/* Please set k parameter value.*/k = 3.1;return k;",String -option=39,expression,"Double l;/* Please set l parameter value.*/l = 3.1;return l;",String -option=40,expression,"Double k;/* Please set k parameter value.*/k = 3.1;return k;",String -option=41,expression,"Double l;/* Please set l parameter value.*/l = 3.1;return l;",String' %(pwd, pwd, pwd, pwd, pwd, pwd, pwd, pwd, pwd, pwd, pwd))

# compare two files and check if they are equal
# bscore_meanSD.csv
file1 = "plate16x24/bscore_meanSD.csv"
file2 = "test_data/bscore_meanSD.csv"
assert filecmp.cmp(file1, file2), 'Something is wrong with Mean-SD hit identification (CSV output)...'
# bscore_meanSD.xls
# convert XLS to CSV
file1 = "plate16x24/bscore_meanSD.xls"
file2 = "test_data/bscore_meanSD.xls"
file3 = "test_data/bscore_meanSDxlsI"
file4 = "test_data/bscore_meanSDxlsII"
xls2csv(file1,file3)
xls2csv(file2,file4)
assert filecmp.cmp("%s0.csv" %file3, "%s0.csv" %file4), 'Something is wrong with Mean-SD hit identification (XLS output)...'
# bscore_medianMAD.csv
file1 = "plate16x24/bscore_medianMAD.csv"
file2 = "test_data/bscore_medianMAD.csv"
assert filecmp.cmp(file1, file2), 'Something is wrong with Median-MAD hit identification (CSV output)...'
# bscore_medianMAD.xls
# convert XLS to CSV
file1 = "plate16x24/bscore_medianMAD.xls"
file2 = "test_data/bscore_medianMAD.xls"
file3 = "test_data/bscore_medianMADxlsI"
file4 = "test_data/bscore_medianMADxlsII"
xls2csv(file1,file3)
xls2csv(file2,file4)
assert filecmp.cmp("%s0.csv" %file3, "%s0.csv" %file4), 'Something is wrong with Median-MAD hit identification (XLS output)...'
# bscore_report_meanSD.csv
file1 = "plate16x24/bscore_report_meanSD.csv"
file2 = "test_data/bscore_report_meanSD.csv"
assert filecmp.cmp(file1, file2), 'Something is wrong with report of Mean-SD hit identification (CSV output)...'
# bscore_report_meanSD.xls
# convert XLS to CSV
file1 = "plate16x24/bscore_report_meanSD.xls"
file2 = "test_data/bscore_report_meanSD.xls"
file3 = "test_data/bscore_report_meanSdxlsI"
file4 = "test_data/bscore_report_meanSDxlsII"
xls2csv(file1,file3)
xls2csv(file2,file4)
assert filecmp.cmp("%s0.csv" %file3, "%s0.csv" %file4), 'Something is wrong with report of Mean-SD hit identification (XLS output)...'
# bscore_report_medianMAD.csv
file1 = "plate16x24/bscore_report_medianMAD.csv"
file2 = "test_data/bscore_report_medianMAD.csv"
assert filecmp.cmp(file1, file2), 'Something is wrong with report of Median-MAD hit identification (CSV output)...'
# bscore_report_medianMAD.xls
# convert XLS to CSV
file1 = "plate16x24/bscore_report_medianMAD.xls"
file2 = "test_data/bscore_report_medianMAD.xls"
file3 = "test_data/bscore_report_medianMADxlsI"
file4 = "test_data/bscore_report_medianMADxlsII"
xls2csv(file1,file3)
xls2csv(file2,file4)
assert filecmp.cmp("%s0.csv" %file3, "%s0.csv" %file4), 'Something is wrong with report of Median-MAD hit identification (XLS output)...'

# compare two heatmap images
# input data
image1 = "plate16x24/0.png"
image2 = "test_data/0.png"
assert compare(image1, image2)==0, 'Something is wrong with generation map (heatmap)...'

